      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       program-id. LeaseFile.
           file-control.
           select LeaseFile assign to external LeaseFile
               file status is file-status
               organization is indexed 
               access mode is dynamic
               record key is filerec-id
               .
      
       file section.
       fd LeaseFile.
       copy "LeaseRecord.cpy" replacing ==(prefix)== by ==filerec==. 
       
       working-storage section. 
       01 file-status          pic xx. 
       
       linkage section. 
       01 lnk-status      pic xx. 
       copy "fileoperations.cpy" replacing ==(prefix)== by ==lnk==. 
       copy "LeaseRecord.cpy" replacing ==(prefix)== by ==lnk==.
      
       procedure division using by value lnk-function 
                            by reference lnk-lease lnk-status.
           evaluate lnk-function
               when read-record
                   perform do-read-record    
               when add-record
                   perform do-add-record
               when delete-record
                   perform do-delete-record
               when next-record
                   perform do-next-record
               when update-record
                   perform do-update-record
           end-evaluate
           goback
           .
           
       do-read-record section. 
           open input LeaseFile 
           move file-status to lnk-status
           if file-status = "00" then
               evaluate true
                   when lnk-id <> low-values and lnk-id <> spaces
                       move lnk-id to filerec-id
                       read LeaseFile
                   when other
      *>---------------No key specified - return unsuccessful read
                       move "23" to lnk-status
               end-evaluate
               if file-status = "00"
                   move filerec-lease to lnk-lease
               end-if
               move file-status to lnk-status 
           end-if     
           close LeaseFile
       .
       do-add-record section. 
           open i-o LeaseFile
           evaluate file-status
               when "05"
      *>-------File not created yet
               when "00"
                   continue
               when other
                   move file-status to lnk-status
                   exit section
           end-evaluate

           move lnk-id  to filerec-id
           read LeaseFile
           if file-status = "00"
      * Record already exists - so error
               move "99" to lnk-status
           else
               move lnk-lease to filerec-lease
               write filerec-lease
               move file-status to lnk-status
           end-if
           close LeaseFile
           .
       
       do-delete-record section.
           open i-o LeaseFile
           if file-status <> "00"
               move file-status to lnk-status
               exit section
           end-if

           evaluate true
               when lnk-id <> spaces and lnk-id <> low-values
                   move lnk-id to filerec-id
                   read LeaseFile
                   delete LeaseFile record
              when other
      *>------------No key specified - return unsuccessful read
                   move "23" to file-status

           end-evaluate

           move file-status to lnk-status
           close LeaseFile
           .
       
       do-next-record section. 
           open input LeaseFile
           if file-status <> "00"
               move file-status to lnk-status
               exit section
           end-if

           move lnk-id to filerec-id
           start LeaseFile key > filerec-id
           read LeaseFile next

           move file-status to lnk-status
           if  file-status = "00"
              move filerec-lease to lnk-lease
           end-if
           close LeaseFile
           .
       do-update-record section.
            open i-o LeaseFile
           evaluate file-status
               when "05"
      *>-------File not created yet
               when "00"
                   continue
               when other
                   move file-status to lnk-status
                   exit section
           end-evaluate
           move lnk-id  to filerec-id
           read LeaseFile
           if file-status <> "00"
      * Record does not exist  - so error
               move "99" to lnk-status
           else
               move lnk-lease to filerec-lease
               rewrite filerec-lease
           end-if
           move file-status to lnk-status
           close LeaseFile
          .
       
       
       end program LeaseFile.