////////////////////////////////////////////////////////////////////////////
///
/// Copyright(C) Micro Focus 2015-2016.
/// All rights reserved.
///
/// This sample code is supplied for demonstration purposes only
/// on an "as is" basis and is for use at your own risk.
///
////////////////////////////////////////////////////////////////////////////
package com.microfocus.javaleases;


import MicroFocus.COBOL.Examples.Lettings.Updateable;
import MicroFocus.Examples.AgencyBridge.RecordValidator;


import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;

import com.microfocus.javaleases.components.RecordList;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.SwingConstants;

import java.awt.Component;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

@SuppressWarnings("serial")
public class ItemSelector extends JDialog
{

    private JPanel contentPane;
    private RecordList recordList ;
    private JButton btnNewButton;
    private ActionListener actionListener; 

    
   
    /**
     * Create the frame.
     */
    public ItemSelector(JFrame parent, Iterable<? extends Updateable>iter, RecordValidator validator)
    {
        super(parent, true); 
        setType(Type.UTILITY);
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        setBounds(100, 100, 450, 300);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        setContentPane(contentPane);
        
        recordList = new RecordList();
        recordList.setListSource(iter, validator);
        recordList.addListActionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                btnNewButton.setEnabled(recordList.getSelectedItem() != null);
            }
        });
        
        btnNewButton = new JButton("Ok");
        btnNewButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (actionListener != null)
                {
                    actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, "OK"));
                }
            }
        });
        btnNewButton.setEnabled(false);
        
        JButton btnNewButton_1 = new JButton("Cancel");
        btnNewButton_1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (actionListener != null)
                {
                    actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, "CANCEL"));
                }
            }
        });
        GroupLayout gl_contentPane = new GroupLayout(contentPane);
        gl_contentPane.setHorizontalGroup(
            gl_contentPane.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPane.createSequentialGroup()
                    .addContainerGap()
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
                        .addComponent(recordList, GroupLayout.PREFERRED_SIZE, 365, GroupLayout.PREFERRED_SIZE)
                        .addGroup(gl_contentPane.createSequentialGroup()
                            .addComponent(btnNewButton)
                            .addGap(65)
                            .addComponent(btnNewButton_1)))
                    .addContainerGap(49, Short.MAX_VALUE))
        );
        gl_contentPane.setVerticalGroup(
            gl_contentPane.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPane.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(recordList, GroupLayout.PREFERRED_SIZE, 201, GroupLayout.PREFERRED_SIZE)
                    .addPreferredGap(ComponentPlacement.UNRELATED)
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
                        .addComponent(btnNewButton)
                        .addComponent(btnNewButton_1))
                    .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        gl_contentPane.linkSize(SwingConstants.HORIZONTAL, new Component[] {btnNewButton, btnNewButton_1});
        contentPane.setLayout(gl_contentPane);
        recordList.populateListBox();
    }
    
    public Updateable getSelected()
    {
        return recordList.getSelectedItem(); 
    }
    
    public void addActionListener(ActionListener listener)
    {
        this.actionListener = listener; 
    }
    

  
}
