      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id MicroFocus.COBOL.Examples.Lettings.Agency public.
       
       01 properties               list[type RentalProperty]. 
       01 tenants                  dictionary [string type Tenant]. 
       01 landlords                dictionary [string  type Landlord].
       01 leases                   dictionary [binary-long type Lease].
       
       method-id New.
           create properties
           create tenants
           create leases
           create landlords
       end method. 
       
       method-id GetProperties.
       procedure division returning return-item as list[type MicroFocus.COBOL.Examples.Lettings.RentalProperty].
      *>   copy the list and return the copy
           create return-item
           perform varying nextProperty as type RentalProperty thru properties
               write return-item from nextProperty
           end-perform
       end method.
       
       method-id AddProperty(p as type RentalProperty). 
           write properties from p 
           
       end method. 
       
       
       method-id GetTenants returning return-item as list[type Tenant].
      *>   copy the list and return the copy
           create return-item
           perform varying key nextKey as string thru tenants
               write return-item from tenants[nextKey]
           end-perform
       end method.

       method-id AddTenant (t as type Tenant).
           write tenants from t key t::Email::ToString()    
       end method.

       method-id AddLandlord(l as type Landlord).
           write landlords from l key l::Email::ToString()
       end method.

       method-id LeaseProperty (startDate as type IDate endDate as type IDate
                                leasedProperty as type RentalProperty t as type Tenant)
                      returning result as type Lease.
           set result to new Lease(startDate endDate leasedProperty t ) 
           
       end method.

       method-id LeaseProperty (startDate as type IDate days as binary-long
                               leasedProperty as type RentalProperty t as type Tenant)
                     returning result as type Lease. 
           set result to new Lease(startDate days leasedProperty t )                 
       end method.

       method-id ExtendLease (l as type Lease days as binary-long).
           
       end method.
      
       
       end class.
