      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id WindowsLeases.LandlordView is partial
                 inherits type System.Windows.Forms.Form.

       working-storage section.
       01 landlord                 type Landlord.
       01 store                    type AgencyStore.
       method-id NEW (store as type AgencyStore, landlord as type Landlord).
           invoke self::InitializeComponent()
           set self::landlord to landlord
           set self::store to store
           goback.
       end method.
       
       method-id OnShown (e as type EventArgs) override.
           set personFields::PersonName to landlord::Name
           set personFields::Email to landlord::Email::Address
           invoke ownedList::BeginUpdate()
           perform varying nextRental as type RentalProperty through landlord::GetProperties()
               invoke ownedList::Items::Add(nextRental)
           end-perform
           invoke ownedList::EndUpdate()
       end method. 

       method-id okBtn_Click (sender as object e as type System.EventArgs) final private.
           invoke self::Close()
       end method.

       method-id button1_Click final private.
       procedure division using by value sender as object e as type System.EventArgs.
           declare landlords as type ItemIterator
           declare validator as type ItemValidator
           
           set landlords to method store::GetRentalProperties()
           set validator to delegate using anItem as type Updateable returning isValid as condition-value
                               declare rp = anItem as type RentalProperty
                               set isValid to rp::Owner = null
                         end-delegate
           declare selector = new ItemSelector(landlords validator)  
           set selector::Text = type Messages::PROPERTY_SELECTOR_TITLE
           declare result = selector::ShowDialog(self)
           if result = type DialogResult::OK 
               invoke ownedList::Items::Add(selector::Selected)
               invoke landlord::AddProperty(selector::Selected as type RentalProperty)
           end-if
       
       end method.

       end class.
