      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id WindowsLeases.LeaseView is partial
                 inherits type System.Windows.Forms.Form.

       working-storage section.
       01 lease                type Lease.
       method-id NEW (lease as type Lease).
           invoke self::InitializeComponent()
           set self::lease to lease
           
           goback.
       end method.
       
       method-id OnShown(e as type EventArgs) protected override.
           set leaseBox::Text to lease::Id
           declare endDate = new DateTime(lease::End::Year, lease::End::Month, lease::End::Day)
           declare startDate = new DateTime(lease::Start::Year, lease::Start::Month, lease::Start::Day)
           set startDatePicker::Value to startDate
           set endDatePicker::Value to endDate
           set endDatePicker::MinDate to endDate
           invoke SetStatusText()       
           set tenantBox::Text to lease::Tenant::Email::Address
           set addressBox::Text to lease::Property::Address
       end method. 
       
       method-id SetStatusText() private.
           if lease::IsActive 
               set endDatePicker::Enabled to true
               set cancelLeaseBtn::Enabled to true
               if endDatePicker::Value > new DateTime(lease::End::Year, lease::End::Month, 
                                                      lease::End::Day) 
                   set extendLeaseBtn::Enabled to true
               else
                   set extendLeaseBtn::Enabled to false
               end-if
           else
               set endDatePicker::Enabled to false
               set cancelLeaseBtn::Enabled to false
               set extendLeaseBtn::Enabled to false 
           end-if
           if lease::IsActive 
               set statusBox::Text to type Messages::LEASE_STATUS_ACTIVE
           else if lease::IsCancelled
               set statusBox::Text to type Messages::LEASE_STATUS_CANCELLED
           else
               set statusBox::Text to type Messages::LEASE_STATUS_EXPIRED
           end-if
       end method. 

       method-id extendLeaseBtn_Click (sender as object e as type System.EventArgs) final private.
           declare newEndDate = new DateNet(endDatePicker::Value)
           declare leaseExtension = newEndDate::Subtract(lease::Start)
           invoke lease::ExtendLease(leaseExtension)
           invoke type MessageBox::Show(self, 
                   type Messages::LEASE_EXTENDED_MESSAGE,
                   type Messages::LEASE_DETAILS_TITLE,
                   type MessageBoxButtons::OK, 
                   type MessageBoxIcon::Information)
       end method.

       method-id cancelLeaseBtn_Click (sender as object e as type System.EventArgs) final private.
           declare result = type MessageBox::Show(self, 
                   type Messages::LEASE_CANCELLED_CONFIRMATION,
                   type Messages::LEASE_DETAILS_TITLE,
                   type MessageBoxButtons::OKCancel, 
                   type MessageBoxIcon::Exclamation)
           if result = type DialogResult::OK
               invoke lease::Cancel() 
               invoke SetStatusText()
           end-if
       end method.

       method-id okBtn_Click (sender as object e as type System.EventArgs) final private.
           invoke self::Close()
       end method.

       method-id endDatePicker_ValueChanged (sender as object e as type System.EventArgs) final private.
           invoke SetStatusText()
       end method.

       end class.
