      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id MicroFocus.Examples.AgencyBridge.EventBridge public.
       01 receivers            dictionary[type EventReceiver, dictionary[type Updateable, type EventBridge]] static. 

       01 receiver             type EventReceiver.
       01 sender               type Updateable. 

       method-id New static.
           create receivers
       end method. 

       method-id RegisterForClassEvents(receiver as type EventReceiver) static.
           invoke new EventBridge(receiver)
       end method. 

       
       method-id Register(receiver as type EventReceiver, o as type Updateable) static.  
          declare bridgeDictionary as dictionary[type Updateable, type EventBridge]
          if receivers not contains receiver
               create bridgeDictionary
               set receivers[receiver] to bridgeDictionary
           else
               set bridgeDictionary to receivers[receiver]
           end-if
           if bridgeDictionary not contains o
               declare bridge =  new EventBridge(receiver, o)
               set bridgeDictionary[o] to bridge
           end-if
       end method. 

       method-id Unregister(receiver as type EventReceiver, o as type Updateable) static. 
          declare bridgeDictionary as dictionary[type Updateable, type EventBridge]
          if receivers contains receiver
               set bridgeDictionary to receivers[receiver]
               if bridgeDictionary contains o
                   declare bridge = bridgeDictionary[o]
                   detach method bridge::HandleChangeEvent from o::changeEvent
                   delete bridgeDictionary key o 
               end-if
           end-if
       end method. 

        
      *> Register a receiver for NewObject events against the different agency object classes.
       method-id New(receiver as type EventReceiver) public. 
           set self::receiver to receiver
           attach method HandleNewRecordEvent to type Landlord::NewObjectEvent
           attach method HandleNewRecordEvent to type RentalProperty::NewObjectEvent
           attach method HandleNewRecordEvent to type Tenant::NewObjectEvent
           attach method HandleNewRecordEvent to type Lease::NewObjectEvent
       end method.

      *> Register a receiver for notifications of changes to an object. This constructor 
      *> is private as registration must be done through the static register method to 
      *> avoid multiple registrations for the same receiver against the same object, 
      *> and to enable unregistration.   
       method-id New (receiver as type EventReceiver, o as type Updateable) private. 
           set self::receiver to receiver
           attach method HandleChangeEvent to o::changeEvent    
       end method. 

       method-id HandleChangeEvent(o as type Updateable).
           invoke receiver::UpdatedRecord(o)
       end method. 
       
       method-id HandleNewRecordEvent(o as type Updateable). 
           invoke receiver::NewRecord(o)
       end method.

       end class.
