      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id MicroFocus.COBOL.Examples.Support.AbstractDate implements type IDate abstract.
  
       method-id Subtract (dt as type IDate) returning result as binary-long abstract.
       end method. 

       method-id Add (days as binary-long) returning result as type IDate abstract.
       end method.
       
       property-id Year binary-long abstract. 
           getter. 
       end property. 

       property-id Month binary-long abstract. 
           getter. 
       end property. 

       property-id Day binary-long abstract. 
           getter. 
       end property. 

       method-id GetDayOfWeek returning result as string abstract. 
       end method.

       method-id GetFormattedDate returning result as string abstract.
       end method.
       
      *> If dates are the same, result = 0 
      *> If this date is earlier than o result = -1 
      *> If this date is later than o = +1
       method-id Compare(o as object) returning result as binary-long.
           if o not instance of type IDate then
               raise  new Exception("Can't compare a non-date item to a date") 
           end-if
           declare d2 as type IDate = o as type IDate
           set result to self::Year - d2::Year 
           if result = 0 
               set result to self::Month - d2::Month 
               if result = 0 
                   set result to self::Day - d2::Day
               end-if
           end-if
           set result to function sign (result) 
       end method.        

       method-id CompareTo (obj as object) returning return-item as binary-long.
           set return-item to self::Compare(obj as type IDate)
       end method.
       
       method-id compareTo (obj as object) returning return-item as binary-long.
           set return-item to self::Compare(obj as type IDate)
       end method. 
      $if JVMGEN set 
       method-id toString() returning result as string override.
      $else 
       method-id ToString() returning result as string override.
      $end 
           set result to GetFormattedDate()
       end method. 
       
       
       method-id Hash() returning result as binary-long. 
           set result to ((self::Day * 2) + self::Month) * 2 + self::Year
       end method. 
       end class.
