      $if NOJVMGEN set 
      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id MicroFocus.COBOL.Examples.Support.DateNet inherits type AbstractDate.
       01 dtRepresentation     type DateTime.

      *>
      *> Empty ctor - returns the current date. 
      *>
        method-id New () public.
           set dtRepresentation to type DateTime::Now
       end method. 
      
      *>
      *> Constructor to return a specified date. 
      *>
       method-id New (year as binary-long, month as binary-long, #day as binary-long).
           set dtRepresentation to new DateTime(year month #day)
       
       end method. 
       
      *>
      *> Constructor to create a date with the value passed in
      *> as an IDate.
      *>
       method-id New (dt as type IDate).
           invoke self::New(dt::Year dt::Month dt::Day)
       end method. 
       
      *>
      *> Constructor to create a date from a DateTime instance.
      *>
       method-id New(dt as type DateTime).
           move dt to dtRepresentation 
       end method. 
         
       property-id Year binary-long public override. 
       getter.
           set property-value to dtRepresentation::Year
       end property. 
       
       property-id Month binary-long public override. 
       getter. 
           set property-value to dtRepresentation::Month
       end property. 
       
       property-id Day binary-long public override. 
       getter. 
           set property-value to dtRepresentation::Day
       end property. 
     
       method-id Subtract (dt as type IDate) returning return-item as binary-long override.
           declare dn as type DateNet = new DateNet(dt)
           declare ts as type TimeSpan = dtRepresentation::Subtract(dn::dtRepresentation)
           set return-item to ts::Days
       end method.

       method-id Add (days as binary-long) returning return-item as type IDate override.
           declare ts as type TimeSpan = new TimeSpan(days 0 0 0)
           declare resultDt as type DateTime = dtRepresentation::Add(ts)
           set return-item to new DateNet(resultDt)
        end method.

       method-id GetDayOfWeek returning return-item as string override.
           set return-item to dtRepresentation::DayOfWeek
       end method.

       method-id GetFormattedDate returning return-item as string override.
           set return-item to dtRepresentation::ToShortDateString()
       end method. 
       
       method-id GetHashCode() returning  result as binary-long override. 
           set result to super::Hash()
       end method. 
      
       method-id ToString() returning result as string override. 
           set result to GetFormattedDate()
       end method. 

       method-id Equals(o as object) returning result as condition-value override.
           set result to CompareTo(o) = 0
       end method. 
       
       end class.
       
      $end 