////////////////////////////////////////////////////////////////////////////
///
/// Copyright(C) Micro Focus 2015-2016.
/// All rights reserved.
///
/// This sample code is supplied for demonstration purposes only
/// on an "as is" basis and is for use at your own risk.
///
////////////////////////////////////////////////////////////////////////////
package com.microfocus.javaleases;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import MicroFocus.AgencyText.Messages;
import MicroFocus.COBOL.Examples.Lettings.Lease;
import MicroFocus.COBOL.Examples.Support.IDate;

import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.SwingConstants;

import java.awt.Component;

import com.microfocus.javaleases.components.DateField;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

@SuppressWarnings("serial")
public class LeaseView extends JFrame
{

    private JPanel contentPane;
    private Lease lease; 
    private JTextField leaseBox;
    private DateField endDateBox;
    private JTextField statusBox;
    private JTextField tenantBox;
    private JTextField addressBox;
    private JButton btnExtendLease;
    private JButton btnCancelLease;
    private JButton btnDone;
    private DateField startDateBox;


    /**
     * Create the frame.
     */
    public LeaseView(final MainWindow parent, Lease lease)
    {
        this.lease = lease; 
        setType(Type.UTILITY);
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        setBounds(100, 100, 518, 412);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        setContentPane(contentPane);
        
        JPanel panel = new JPanel();
        panel.setBorder(new TitledBorder(null, "Lease", TitledBorder.LEADING, TitledBorder.TOP, null, null));
        
        JLabel lblTenantEmail = new JLabel("Tenant Email");
        
        tenantBox = new JTextField();
        tenantBox.setEnabled(false);
        tenantBox.setColumns(10);
        
        JLabel lblPropertyAddress = new JLabel("Property Address");
        
        addressBox = new JTextField();
        addressBox.setEnabled(false);
        addressBox.setColumns(10);
        
        btnDone = new JButton("Done");
        btnDone.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                parent.closeMe(LeaseView.this);
            }
        });
        GroupLayout gl_contentPane = new GroupLayout(contentPane);
        gl_contentPane.setHorizontalGroup(
            gl_contentPane.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPane.createSequentialGroup()
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_contentPane.createSequentialGroup()
                            .addContainerGap()
                            .addComponent(panel, GroupLayout.PREFERRED_SIZE, 443, GroupLayout.PREFERRED_SIZE))
                        .addGroup(gl_contentPane.createSequentialGroup()
                            .addGap(28)
                            .addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
                                .addComponent(lblTenantEmail)
                                .addComponent(lblPropertyAddress))
                            .addGap(24)
                            .addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING, false)
                                .addComponent(addressBox)
                                .addComponent(tenantBox, GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE)
                                .addComponent(btnDone))))
                    .addContainerGap(172, Short.MAX_VALUE))
        );
        gl_contentPane.setVerticalGroup(
            gl_contentPane.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPane.createSequentialGroup()
                    .addGap(20)
                    .addComponent(panel, GroupLayout.PREFERRED_SIZE, 222, GroupLayout.PREFERRED_SIZE)
                    .addGap(18)
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
                        .addComponent(lblTenantEmail)
                        .addComponent(tenantBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                    .addGap(18)
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
                        .addComponent(lblPropertyAddress)
                        .addComponent(addressBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                    .addPreferredGap(ComponentPlacement.RELATED, 16, Short.MAX_VALUE)
                    .addComponent(btnDone)
                    .addContainerGap())
        );
        
        JLabel lblNewLabel = new JLabel("Lease id");
        
        leaseBox = new JTextField();
        leaseBox.setEnabled(false);
        leaseBox.setColumns(10);
        
        JLabel lblOm = new JLabel("From");
        
        JLabel lblTo = new JLabel("To");
        
        JLabel lblStatus = new JLabel("Status");
        
        statusBox = new JTextField();
        statusBox.setEnabled(false);
        statusBox.setColumns(10);
        
        btnCancelLease = new JButton("Cancel Lease");
        btnCancelLease.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                btnCancelLeaseClick(); 
            }
        });
        
        btnExtendLease = new JButton("Extend Lease");
        btnExtendLease.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                btnExtendLeaseClick();
            }
        });
        
        endDateBox = new DateField();
        endDateBox.addValidationListener(new ActionListener(){
            @Override
            public void actionPerformed(ActionEvent e)
            {
                setStatusText();
            }
        });
        
        startDateBox = new DateField();
        startDateBox.setEnabled(false);
        GroupLayout gl_panel = new GroupLayout(panel);
        gl_panel.setHorizontalGroup(
            gl_panel.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_panel.createSequentialGroup()
                    .addGroup(gl_panel.createParallelGroup(Alignment.LEADING, false)
                        .addGroup(gl_panel.createSequentialGroup()
                            .addContainerGap()
                            .addGroup(gl_panel.createParallelGroup(Alignment.LEADING)
                                .addComponent(lblTo)
                                .addComponent(lblStatus)
                                .addComponent(lblOm))
                            .addGap(8))
                        .addGroup(Alignment.TRAILING, gl_panel.createSequentialGroup()
                            .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(lblNewLabel)))
                    .addPreferredGap(ComponentPlacement.UNRELATED)
                    .addGroup(gl_panel.createParallelGroup(Alignment.LEADING)
                        .addComponent(leaseBox, GroupLayout.DEFAULT_SIZE, 364, Short.MAX_VALUE)
                        .addComponent(startDateBox, GroupLayout.PREFERRED_SIZE, 114, GroupLayout.PREFERRED_SIZE)
                        .addComponent(endDateBox, GroupLayout.PREFERRED_SIZE, 107, GroupLayout.PREFERRED_SIZE)
                        .addComponent(statusBox, 265, 265, 265))
                    .addContainerGap())
                .addGroup(gl_panel.createSequentialGroup()
                    .addGap(98)
                    .addComponent(btnCancelLease)
                    .addPreferredGap(ComponentPlacement.RELATED, 93, Short.MAX_VALUE)
                    .addComponent(btnExtendLease)
                    .addGap(46))
        );
        gl_panel.setVerticalGroup(
            gl_panel.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_panel.createSequentialGroup()
                    .addGroup(gl_panel.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_panel.createSequentialGroup()
                            .addGap(14)
                            .addComponent(leaseBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                        .addGroup(gl_panel.createSequentialGroup()
                            .addGap(20)
                            .addComponent(lblNewLabel)))
                    .addGap(24)
                    .addGroup(gl_panel.createParallelGroup(Alignment.LEADING)
                        .addGroup(Alignment.TRAILING, gl_panel.createSequentialGroup()
                            .addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
                                .addComponent(lblOm)
                                .addComponent(startDateBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                            .addGap(18)
                            .addComponent(lblTo)
                            .addGap(27)
                            .addComponent(lblStatus))
                        .addGroup(Alignment.TRAILING, gl_panel.createSequentialGroup()
                            .addComponent(endDateBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                            .addGap(18)
                            .addComponent(statusBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
                    .addPreferredGap(ComponentPlacement.RELATED, 14, Short.MAX_VALUE)
                    .addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
                        .addComponent(btnCancelLease)
                        .addComponent(btnExtendLease))
                    .addContainerGap())
        );
        gl_panel.linkSize(SwingConstants.HORIZONTAL, new Component[] {endDateBox, startDateBox});
        gl_panel.linkSize(SwingConstants.HORIZONTAL, new Component[] {btnCancelLease, btnExtendLease});
        panel.setLayout(gl_panel);
        contentPane.setLayout(gl_contentPane);
    }
    
    public void setVisible(boolean visible)
    {
        super.setVisible(visible);
        if (visible)
        {
            leaseBox.setText(lease.getId());
            startDateBox.setDate(lease.getStart());
            endDateBox.setDate(lease.getEnd());
            setStatusText(); 
            tenantBox.setText(lease.getTenant().getEmail().getAddress());
            addressBox.setText(lease.getProperty().getAddress().toString());
        }
    }

    private void setStatusText()
    {
        if (lease.IsActive())
        {
            endDateBox.setEnabled(true);
            btnCancelLease.setEnabled(true);
            btnExtendLease.setEnabled(endDateBox.getDate() != null && 
                                      lease.getEnd().Compare(endDateBox.getDate()) < 0);
        }
        else
        {
            endDateBox.setEnabled(false);
            btnCancelLease.setEnabled(false);
            btnExtendLease.setEnabled(false);
        }
        if (lease.IsActive())
        {
            statusBox.setText((Messages.LEASE_STATUS_ACTIVE));
        }
        else if (lease.IsCancelled())
        {
            statusBox.setText((Messages.LEASE_STATUS_CANCELLED));
        }
        else
        {
            statusBox.setText((Messages.LEASE_STATUS_EXPIRED));
        }
    }
    
    private void btnExtendLeaseClick()
    {
        IDate newEndDate = endDateBox.getDate(); 
        lease.ExtendLease(newEndDate);
        JOptionPane.showMessageDialog(this,
                Messages.LEASE_EXTENDED_MESSAGE,
                Messages.LEASE_DETAILS_TITLE,
                JOptionPane.INFORMATION_MESSAGE);
    }
    
    private void btnCancelLeaseClick()
    {
        int result = JOptionPane.showConfirmDialog(this, 
                Messages.LEASE_CANCELLED_CONFIRMATION,
                Messages.LEASE_DETAILS_TITLE,
                JOptionPane.OK_CANCEL_OPTION,
                JOptionPane.QUESTION_MESSAGE);
        if (result == JOptionPane.OK_OPTION)
        {
            lease.Cancel();
            setStatusText(); 
        }
    }
}
