////////////////////////////////////////////////////////////////////////////
///
/// Copyright(C) Micro Focus 2015-2016.
/// All rights reserved.
///
/// This sample code is supplied for demonstration purposes only
/// on an "as is" basis and is for use at your own risk.
///
////////////////////////////////////////////////////////////////////////////
package com.microfocus.javaleases;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;


import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;

import MicroFocus.AgencyText.Messages;
import MicroFocus.COBOL.Examples.Lettings.Lease;
import MicroFocus.COBOL.Examples.Lettings.LeaseException;
import MicroFocus.COBOL.Examples.Lettings.RentalProperty;
import MicroFocus.COBOL.Examples.Lettings.Tenant;
import MicroFocus.COBOL.Examples.Lettings.Updateable;
import MicroFocus.COBOL.Examples.Support.IDate;
import MicroFocus.COBOL.Store.AgencyStore;
import MicroFocus.Examples.AgencyBridge.RecordValidator;

import com.microfocus.javaleases.components.AddressFields;

import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JLabel;

import com.microfocus.javaleases.components.DateField;

import javax.swing.LayoutStyle.ComponentPlacement;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

@SuppressWarnings("serial")
public class NewLease extends JFrame
{

    private JPanel contentPane;
    private AddressFields addressFields;
    private JTextField tenantField;
    private JButton btnOk;
    private AgencyStore store;
    private MainWindow parent; 
    private RentalProperty rentalProperty; 
    private Tenant tenant; 
    private DateField startDateField;
    private DateField endDateField;
    
    public NewLease(MainWindow parent, AgencyStore store, RentalProperty rentalProperty)
    {
        this();
        this.store = store;
        this.parent = parent; 
        this.rentalProperty = rentalProperty; 
    }

     /**
     * Create the frame.
     */
    public NewLease()
    {
         setType(Type.UTILITY);
         setTitle("New Lease");
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        setBounds(100, 100, 520, 470);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        setContentPane(contentPane);
        
        addressFields = new AddressFields();
        
        JButton btnTenant = new JButton("Tenant");
        btnTenant.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                btnTenantClick();
            }
        });
        
        tenantField = new JTextField();
        tenantField.setColumns(10);
        
        JLabel lblLeaseStart = new JLabel("Lease start");
        
        JLabel lblLeaseEnd = new JLabel("Lease end");
        
        startDateField = new DateField();
        startDateField.addValidationListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setOkBtnState();
            }
        });
        
        endDateField = new DateField();
        endDateField.addValidationListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                setOkBtnState();
            }
        });
        
        btnOk = new JButton("OK");
        btnOk.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                btnOkClick();
            }
        });
        
        JButton btnCancel = new JButton("Cancel");
        btnCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                parent.closeMe(NewLease.this);
            }
        });
        GroupLayout gl_contentPane = new GroupLayout(contentPane);
        gl_contentPane.setHorizontalGroup(
            gl_contentPane.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPane.createSequentialGroup()
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_contentPane.createSequentialGroup()
                            .addContainerGap()
                            .addComponent(addressFields, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                        .addGroup(gl_contentPane.createSequentialGroup()
                            .addGap(23)
                            .addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
                                .addComponent(btnTenant)
                                .addComponent(lblLeaseStart)
                                .addComponent(lblLeaseEnd))
                            .addGap(68)
                            .addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
                                .addComponent(startDateField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                .addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING, false)
                                    .addGroup(Alignment.LEADING, gl_contentPane.createSequentialGroup()
                                        .addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
                                            .addComponent(endDateField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                                            .addComponent(btnOk))
                                        .addPreferredGap(ComponentPlacement.RELATED, 116, Short.MAX_VALUE)
                                        .addComponent(btnCancel))
                                    .addComponent(tenantField, Alignment.LEADING, GroupLayout.PREFERRED_SIZE, 267, GroupLayout.PREFERRED_SIZE)))))
                    .addContainerGap(34, Short.MAX_VALUE))
        );
        gl_contentPane.setVerticalGroup(
            gl_contentPane.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPane.createSequentialGroup()
                    .addComponent(addressFields, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addGap(33)
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
                        .addComponent(btnTenant)
                        .addComponent(tenantField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                    .addGap(27)
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
                        .addComponent(lblLeaseStart)
                        .addComponent(startDateField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                    .addGap(28)
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
                        .addComponent(lblLeaseEnd)
                        .addComponent(endDateField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                    .addPreferredGap(ComponentPlacement.RELATED, 28, Short.MAX_VALUE)
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
                        .addComponent(btnCancel)
                        .addComponent(btnOk))
                    .addContainerGap())
        );
        contentPane.setLayout(gl_contentPane);
    }
    
    public void setVisible(boolean enabled)
    {
        super.setVisible(enabled);
        addressFields.setAddress(rentalProperty.getAddress());
        addressFields.setEnabled(false);
        setOkBtnState();
    }
    
    protected boolean isReadyToCreate()
    {
        IDate startDate = startDateField.getDate(); 
        IDate endDate = endDateField.getDate(); 
        if (startDate != null && endDate != null)
        {
            return (tenant != null) && (startDate.Compare(endDate) < 0);
        }
        else
            return false; 
    }
    
    protected void setOkBtnState()
    {
        btnOk.setEnabled(isReadyToCreate());
    }
    
    protected void btnTenantClick()
    {
        final ItemSelector tenantSelector = new ItemSelector(this, 
                                                store.GetTenants(), 
         new RecordValidator(){
            public boolean Validate(Updateable record)
            {
                Tenant t = (Tenant) record; 
                return t.getLease() == null; 
            }
        });
        
        tenantSelector.addActionListener(new ActionListener(){
            @Override
            public void actionPerformed(ActionEvent e)
            {
                if (e.getActionCommand().equalsIgnoreCase("OK"))
                {
                    tenant = (Tenant) tenantSelector.getSelected() ; 
                    tenantField.setText( tenant.getEmail().getAddress());
                }
                tenantSelector.setVisible(false);
                tenantSelector.dispose();
                setOkBtnState();
            }
        });
        
        tenantSelector.setVisible(true);
    }

    private void btnOkClick()
    {
        if (isReadyToCreate())
        {
            try
            {
                Lease newLease = new Lease(startDateField.getDate(), 
                                           endDateField.getDate(), rentalProperty, tenant); 
                store.Save(newLease);
                parent.closeMe(this);
            }
            catch (Exception e)
            {
                if (e instanceof LeaseException)
                {
                    String errMsg = Messages.NEW_LEASE_CREATE_ERROR + e.getMessage(); 
                    JOptionPane.showMessageDialog(this,
                            errMsg, 
                            Messages.ADD_RENTAL_MSG_TITLE,
                            JOptionPane.ERROR_MESSAGE); 
                }
            }
        }
    }
}
