////////////////////////////////////////////////////////////////////////////
///
/// Copyright(C) Micro Focus 2015-2016.
/// All rights reserved.
///
/// This sample code is supplied for demonstration purposes only
/// on an "as is" basis and is for use at your own risk.
///
////////////////////////////////////////////////////////////////////////////
package com.microfocus.javaleases;


import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import MicroFocus.COBOL.Examples.Lettings.Tenant;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import com.microfocus.javaleases.components.PersonFields;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.SwingConstants;
import java.awt.Component;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

@SuppressWarnings("serial")
public class TenantView extends JFrame
{
    private Tenant tenant;
    private JPanel contentPane;
    private PersonFields personFields;
    private JTextField propertyAddressBox;
    private JTextField startDateBox;
    private JTextField endDateBox;
    private JButton btnCancelLease;
    private JButton btnDone;


    /**
     * Create the frame.
     */
    public TenantView(final MainWindow parent, final Tenant tenant)
    {
        setType(Type.UTILITY);
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        this.tenant = tenant; 
        setBounds(100, 100, 555, 382);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        setContentPane(contentPane);
        
        personFields = new PersonFields();
        
        JPanel panel = new JPanel();
        panel.setBorder(new TitledBorder(null, "Lease", TitledBorder.LEADING, TitledBorder.TOP, null, null));
        
        btnDone = new JButton("Done");
        btnDone.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                parent.closeMe(TenantView.this);
            }
        });
        GroupLayout gl_contentPane = new GroupLayout(contentPane);
        gl_contentPane.setHorizontalGroup(
            gl_contentPane.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPane.createSequentialGroup()
                    .addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
                        .addGroup(gl_contentPane.createSequentialGroup()
                            .addContainerGap()
                            .addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
                                .addComponent(panel, GroupLayout.PREFERRED_SIZE, 457, GroupLayout.PREFERRED_SIZE)
                                .addComponent(personFields, GroupLayout.PREFERRED_SIZE, 337, GroupLayout.PREFERRED_SIZE)))
                        .addGroup(gl_contentPane.createSequentialGroup()
                            .addGap(177)
                            .addComponent(btnDone)))
                    .addContainerGap(62, Short.MAX_VALUE))
        );
        gl_contentPane.setVerticalGroup(
            gl_contentPane.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_contentPane.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(personFields, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                    .addGap(18)
                    .addComponent(panel, GroupLayout.PREFERRED_SIZE, 152, GroupLayout.PREFERRED_SIZE)
                    .addGap(18)
                    .addComponent(btnDone)
                    .addContainerGap(17, Short.MAX_VALUE))
        );
        
        JLabel lblPropertyAddress = new JLabel("Property address");
        
        propertyAddressBox = new JTextField();
        propertyAddressBox.setEnabled(false);
        propertyAddressBox.setColumns(10);
        
        JLabel lblFrom = new JLabel("From");
        
        startDateBox = new JTextField();
        startDateBox.setEnabled(false);
        startDateBox.setColumns(10);
        
        JLabel lblTo = new JLabel("To");
        
        endDateBox = new JTextField();
        endDateBox.setEnabled(false);
        endDateBox.setColumns(10);
        
        btnCancelLease = new JButton("Cancel Lease");
        btnCancelLease.setEnabled(false);
        btnCancelLease.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
               if (tenant.getLease() != null)
               {
                   tenant.getLease().Cancel(); 
                   propertyAddressBox.setText("");
                   startDateBox.setText("");
                   endDateBox.setText("");   
               }
            }
        });
        GroupLayout gl_panel = new GroupLayout(panel);
        gl_panel.setHorizontalGroup(
            gl_panel.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_panel.createSequentialGroup()
                    .addContainerGap()
                    .addGroup(gl_panel.createParallelGroup(Alignment.LEADING)
                        .addComponent(lblPropertyAddress)
                        .addComponent(lblFrom))
                    .addGap(18)
                    .addGroup(gl_panel.createParallelGroup(Alignment.LEADING, false)
                        .addComponent(propertyAddressBox, GroupLayout.PREFERRED_SIZE, 245, GroupLayout.PREFERRED_SIZE)
                        .addGroup(gl_panel.createSequentialGroup()
                            .addGroup(gl_panel.createParallelGroup(Alignment.LEADING)
                                .addComponent(btnCancelLease)
                                .addComponent(startDateBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                            .addGap(27)
                            .addComponent(lblTo)
                            .addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(endDateBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
                    .addContainerGap(89, Short.MAX_VALUE))
        );
        gl_panel.setVerticalGroup(
            gl_panel.createParallelGroup(Alignment.LEADING)
                .addGroup(gl_panel.createSequentialGroup()
                    .addContainerGap()
                    .addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
                        .addComponent(lblPropertyAddress)
                        .addComponent(propertyAddressBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                    .addGap(18)
                    .addGroup(gl_panel.createParallelGroup(Alignment.TRAILING)
                        .addComponent(lblFrom)
                        .addGroup(gl_panel.createParallelGroup(Alignment.BASELINE)
                            .addComponent(lblTo)
                            .addComponent(endDateBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
                            .addComponent(startDateBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
                    .addGap(18)
                    .addComponent(btnCancelLease)
                    .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        gl_panel.linkSize(SwingConstants.HORIZONTAL, new Component[] {startDateBox, endDateBox});
        panel.setLayout(gl_panel);
        contentPane.setLayout(gl_contentPane);
    }
    
    public void setVisible(boolean visible)
    {
        super.setVisible(true);
        if (visible)
        {
            personFields.setPersonName(tenant.getName());
            personFields.setEmail(tenant.getEmail().getAddress());
            if (tenant.getLease() != null)
            {
                startDateBox.setText(tenant.getLease().getStart().toString());
                endDateBox.setText(tenant.getLease().getEnd().toString());
                propertyAddressBox.setText(tenant.getLease().getProperty().getAddress().toString());
                btnCancelLease.setEnabled(true);
            }
        }
    }
}
