////////////////////////////////////////////////////////////////////////////
///
/// Copyright(C) Micro Focus 2015-2016.
/// All rights reserved.
///
/// This sample code is supplied for demonstration purposes only
/// on an "as is" basis and is for use at your own risk.
///
////////////////////////////////////////////////////////////////////////////
package com.microfocus.javaleases.components;

import javax.swing.JPanel;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JLabel;
import javax.swing.JTextField;

import MicroFocus.COBOL.Examples.Support.Address;

public class AddressFields extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2944342801550986368L;
	private JTextField addressLineBox;
	private JTextField cityBox;
	private JTextField stateBox;
	private JTextField postalCodeBox;

	/**
	 * Create the panel.
	 */
	public AddressFields() 
	{
		
		JLabel lblAddressLine = new JLabel("Address Line 1 ");
		
		JLabel lblCity = new JLabel("City");
		
		JLabel lblState = new JLabel("State");
		
		JLabel lblPostalCode = new JLabel("Postal Code");
		
		addressLineBox = new JTextField();
		addressLineBox.setColumns(10);
		
		cityBox = new JTextField();
		cityBox.setColumns(10);
		
		stateBox = new JTextField();
		stateBox.setColumns(10);
		
		postalCodeBox = new JTextField();
		postalCodeBox.setColumns(10);
		GroupLayout groupLayout = new GroupLayout(this);
		groupLayout.setHorizontalGroup(
		    groupLayout.createParallelGroup(Alignment.LEADING)
		        .addGroup(groupLayout.createSequentialGroup()
		            .addGap(39)
		            .addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
		                .addComponent(lblAddressLine)
		                .addComponent(lblCity)
		                .addComponent(lblState)
		                .addComponent(lblPostalCode))
		            .addGap(33)
		            .addGroup(groupLayout.createParallelGroup(Alignment.LEADING, false)
		                .addComponent(stateBox)
		                .addComponent(cityBox)
		                .addComponent(addressLineBox, GroupLayout.DEFAULT_SIZE, 271, Short.MAX_VALUE)
		                .addComponent(postalCodeBox, GroupLayout.PREFERRED_SIZE, 133, GroupLayout.PREFERRED_SIZE))
		            .addContainerGap(34, Short.MAX_VALUE))
		);
		groupLayout.setVerticalGroup(
		    groupLayout.createParallelGroup(Alignment.LEADING)
		        .addGroup(groupLayout.createSequentialGroup()
		            .addGap(31)
		            .addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
		                .addComponent(lblAddressLine)
		                .addComponent(addressLineBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
		            .addGap(26)
		            .addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
		                .addComponent(lblCity)
		                .addComponent(cityBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
		            .addGap(26)
		            .addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
		                .addComponent(lblState)
		                .addComponent(stateBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
		            .addGap(32)
		            .addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
		                .addComponent(lblPostalCode)
		                .addComponent(postalCodeBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
		            .addContainerGap(18, Short.MAX_VALUE))
		);
		setLayout(groupLayout);
	}
	
	public void setEnabled(boolean enabled)
	{
		addressLineBox.setEnabled(enabled);
		cityBox.setEnabled(enabled);
		stateBox.setEnabled(enabled);
		postalCodeBox.setEnabled(enabled);
	}
	
	public boolean isAddressValid()
	{
	    String addressLine1 = addressLineBox.getText().trim(); 
	    String postalCode = postalCodeBox.getText().trim(); 
	    return addressLine1.length() > 0 && postalCode.length() > 0; 
	}
	
	public Address getAddress()
	{
		return new Address(addressLineBox.getText().trim(), cityBox.getText().trim(),
				           stateBox.getText().trim(), postalCodeBox.getText().trim()); 
	}
	
	public void setAddress(Address address)
	{
		addressLineBox.setText(address.getAddress1());
		cityBox.setText(address.getCity());;
		stateBox.setText(address.getState());
		postalCodeBox.setText(address.getPostalCode());
	}
}
