      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id MicroFocus.COBOL.Examples.Lettings.RentalProperty public
                inherits type AbstractUpdateable.
       01 NewObjectEvent       event type ChangeDelegate public static. 
                
       01 #Address                     type Address property with no set.  
       01 rent                         binary-long. 
       01 #Lease                       type Lease property with no set.   
       01 landlord                     type Landlord property.  

       method-id New(argAddress as type Address). 
           set #Address to argAddress
           invoke self::OnNew()
       end method. 
       
       method-id IsAvailable() returning result as condition-value. 
      *>   Return true if there is no lease. 
           set result to #Lease = null and not #Lease::IsActive()
       end method.
       
        method-id LeaseProperty(lease as type Lease) internal.
           if #Lease <> null
               raise new LeaseException("Not available")
           end-if
           set #Lease to lease
           invoke self::OnChange()
       end method. 
       
       property-id Owner  type Landlord.
           getter.
               set property-value to landlord
           setter.
               set landlord to property-value
               invoke self::OnChange()
       end property.
       
       property-id MonthlyRent binary-long.
       getter.
           set property-value to rent
       setter.
           set rent to property-value
           invoke self::OnChange()
       end property.
       
       method-id CancelLease() internal.
           set #Lease to null
           invoke self::OnChange()
       end method. 
       
       method-id GetDisplayValue returning result as string override 
           declare rentalStatus as string 
           if #Lease = null 
               set rentalStatus to "Free" 
           else    
               set rentalStatus to "Leased"
           end-if
           set result to rentalStatus & " | " & "Rent: " & rent 
                          & " | Address: " & #Address::ShortValue
       end method. 
       
       
       method-id OnNew() protected.
           declare localEvent = NewObjectEvent
           if localEvent <> null
               invoke run localEvent(self)
           end-if
       end method.       
       end class.
       