      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id MicroFocus.COBOL.Examples.Lettings.Tenant 
                inherits type Person public.
       01 Lease                type Lease property with no set.  
       01 NewObjectEvent       event type ChangeDelegate public static. 
         
    
       method-id New(#name as string email as string).  
           invoke super::New(#name email)
       end method.
       
       method-id CancelLease() internal. 
           set Lease to null
           invoke self::OnChange()
       end method. 
       
       method-id StartLease(lease as type Lease) internal.
           if self::Lease = null or not self::Lease::IsActive()
               set self::Lease to lease
               invoke self::OnChange()
           else 
               raise new LeaseException("Tenant already has lease")
           end-if
       end method. 
   
       method-id GetDisplayValue returning result as string override. 
           set result to "Tenant: " & super::GetDisplayValue
       end method. 

       method-id OnNew() protected override.
           declare localEvent = NewObjectEvent
           if localEvent <> null
               invoke run localEvent(self)
           end-if
       end method.       
       
       end class.
