      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id WindowsLeases.ItemSelector is partial
                 inherits type System.Windows.Forms.Form.


       working-storage section.
       01 enumerator       type ItemIterator.
       01 isValid          type ItemValidator. 
       01 ok               condition-value. 
       method-id NEW (enumerator as type ItemIterator, validator as type ItemValidator).
           invoke self::InitializeComponent()
           set self::enumerator to enumerator
           set self::isValid to validator
           set okBtn::Enabled to false *> should only be enabled when tenant is selected 
           goback.
       end method.
       
       method-id OnShown(e as type EventArgs) protected override.
           invoke super::OnShown(e)
           invoke itemList::BeginUpdate()
           perform varying nextItem as type Updateable through run enumerator
               if run isValid(nextItem) 
                   invoke itemList::Items::Add(nextItem)
               end-if
           end-perform
           invoke itemList::EndUpdate()
       end method.
       
       property-id Selected type Updateable. 
           getter.
               set property-value to itemList::SelectedItem as type Updateable
       end property. 

       method-id okBtn_Click (sender as object e as type System.EventArgs) final private.
           set ok to true
           invoke self::Close() 
       end method.
       
       method-id OnFormClosed(e as type FormClosedEventArgs) public override.
           if ok
               set DialogResult to type DialogResult::OK
           end-if
       end method.

       method-id itemList_SelectedIndexChanged 
                             (sender as object e as type System.EventArgs) final private.
           if itemList::SelectedIndex < 0 
               set okBtn::Enabled to false
           else 
               set okBtn::Enabled to true
           end-if
       end method.
       
       end class.
