      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id WindowsLeases.NewLease is partial
                 inherits type System.Windows.Forms.Form.

       working-storage section.
       01 store            type AgencyStore. 
       01 rental           type RentalProperty.
       01 tenant           type Tenant. 
       method-id New(store as type AgencyStore, rental as type RentalProperty).
       procedure division.
           set self::store to store
           set self::rental to rental
           invoke self::InitializeComponent()
           goback.
       end method.
       
       
       method-id OnShown(e as type EventArgs) override protected.
           invoke super::OnShown(e)
           set addressFields1::AddressLine1 to rental::Address::Address1
           set addressFields1::City to rental::Address::City
           set addressFields1::State to rental::Address::State
           set addressFields1::PostalCode to rental::Address::PostalCode
           invoke SetOkBtnState()
       end method.

       method-id tenantBtn_Click (sender as object e as type System.EventArgs) final private.
           declare tenantIterator as type ItemIterator
           set tenantIterator to method store::GetTenants
           declare validator as type ItemValidator
           set validator to delegate (item as type Updateable) returning isValid as condition-value
                                declare t = item as type Tenant
                                set isValid to t::Lease = null
                            end-delegate
           declare selector = new ItemSelector(tenantIterator, validator)
           declare result = selector::ShowDialog(self)
           evaluate result 
           when type DialogResult::OK
               set tenant to selector::Selected as type Tenant  
               set tenantBox::Text to tenant::Email::Address
          end-evaluate
          invoke SetOkBtnState()
       end method.
     
      *> Have we got a tenant and valid dates.       
       method-id IsReadyToCreate() returning isReady as condition-value protected.
           set isReady to tenant <> null and 
                          dateTimePicker1::Value < dateTimePicker2::Value
       end method. 
      
       method-id SetOkBtnState() protected.
           set okBtn::Enabled to IsReadyToCreate()
       end method. 

       method-id dateTimePicker_ValueChanged(sender as object e as type System.EventArgs) final private.
           invoke SetOkBtnState()
       end method.

       method-id okBtn_Click final private.
       procedure division using by value sender as object e as type System.EventArgs.
           try
               declare newLease = new Lease(new DateNet(dateTimePicker1::Value)
                                            new DateNet(dateTimePicker2::Value)
                                             rental, tenant)
               invoke store::Save(newLease)
               invoke self::Close()
           catch ex as type LeaseException
               declare errMsg = type Messages::NEW_LEASE_CREATE_ERROR & ex::Message
               invoke type MessageBox::Show(self, errMsg
                    type Messages::NEW_LEASE_TITLE, 
                    type MessageBoxButtons::OK, 
                    type MessageBoxIcon::Error)
           end-try
           
       end method.
       

       method-id cancelBtn_Click final private.
       procedure division using by value sender as object e as type System.EventArgs.
           invoke self::Close()
       end method.

       end class.
