      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id WindowsLeases.NewPerson is partial
                 inherits type System.Windows.Forms.Form.

       working-storage section.
       01 store                    type AgencyStore.
       01 selector                 type PersonSelector. 
       method-id NEW (store as type AgencyStore, selector as type PersonSelector). 
       procedure division.
           invoke self::InitializeComponent()
           set self::selector to selector
           evaluate self::selector
           when type PersonSelector::Landlord
               set self::Text to type Messages::NEW_LANDLORD_TITLE
           when type PersonSelector::Tenant
               set self::Text to type Messages::NEW_TENANT_TITLE
           end-evaluate
           set self::store to store
           goback.
       end method.

       method-id okBtn_Click final private.
       procedure division using by value sender as object e as type System.EventArgs.
           if size of personFields1::PersonName = 0 or size of personFields1::Email = 0 
               invoke type MessageBox::Show(self, 
                    type Messages::NEW_PERSON_EMPTY_FIELDS, 
                    type Messages::ADD_PERSON_MSG_TITLE, 
                    type MessageBoxButtons::OK, 
                    type MessageBoxIcon::Error)
           else
               if type Email::Validate(personFields1::Email)
                   invoke CreatePerson()    
                   invoke self::Close()
               else
                   invoke type MessageBox::Show(self, 
                        type Messages::INVALID_EMAIL_ADDRESS 
                        type Messages::ADD_PERSON_MSG_TITLE, 
                        type MessageBoxButtons::OK, 
                        type MessageBoxIcon::Error)
               end-if
           end-if
       end method.
       
       method-id CreatePerson private. 
           evaluate self::selector
           when type PersonSelector::Landlord 
               declare l = new Landlord(personFields1::PersonName, personFields1::Email)
               invoke store::Save(l)
           when type PersonSelector::Tenant
               declare t = new Tenant(personFields1::PersonName, personFields1::Email)
               invoke store::Save(t)
           end-evaluate
       end method. 

       method-id cancelBtn_Click final private.
       procedure division using by value sender as object e as type System.EventArgs.
           invoke self::Close()
       end method.

       end class.
       
       enum-id WindowsLeases.PersonSelector.
       78 Landlord.
       78 Tenant. 
       end enum. 
       
